;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************

	TITLE           "GNU-link : CD-Multichanger Emulation"
	SUBTITLE        "Released under the GPL license, (c) S Wood, Oct 2001"

;******************************************************************************
;	Additional Info - Release version  1.8T_01
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; GNUnilink Configuration.
; Uncomment the lines relevant to your board... 
; this should be only configuration required.
;
; Type of PIC
#define		PIC_16F628

; Speed (or closet)
;;--- Only "20MHz" is available.  (T)
#define		SPEED_20MHZ

;******************************************************************************
;;--- CD/MD manual setting		;; Feb. 21 2004  (T)
;;   If You want to select CD/MD mode by Hardware switch manually,
;;   Please Set Here.  (Comment out means Auto-select. default:MD)

;;#define		CdMd_SW

;;-----------------------------------------------------
;;--- Next Disc 			;; Apr. 25 2004 (T)
;;   If You want to remap AS buttom to NextDisc,
;;   Please Set Here.  (Commentout means NOT remap)
;;   (this function is espacially for MDX-5V101R with CD/MD changer)

#define		NextNext

;;-----------------------------------------------------
;;--- BUS_MUX exists flag		;; Feb. 21 2004  (T)
;;   If You want to enjoy displaying countup-style playing-time,
;;   even if you do NOT have the Source Selector (like a XA-30c),
;;   Please Set Here.

#define		IS_BUS_MUX

;******************************************************************************
;;--- DEBUG Mode		;; Feb. 15 2004  (T)
				;; If you want to Release Version, 
;;#define	DEBUG		;; Comment Out This line.
				;;

;******************************************************************************
; Real settings for the PIC - if you need to add a new one do it here, 
; otherwise select one from above

		Radix   DEC
		EXPAND

	IFDEF	PIC_16F628
		Processor       16f628
		include         "p16f628.inc"

;; changed to WDT-OFF for TMR0 interrupt (T) 
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF

#define		PIC_16F62x
#define		PIC_16
	ENDIF

	IFDEF	PIC_16
#define		OUT_PORT	PORTA
#define		OUT_ENA		TRISA
	ENDIF

;******************************************************************************
; A few standard definitions

_ResetVector	set	0x00
_IntVector      set     0x04

TRUE	equ	1
FALSE	equ	0

;******************************************************************************
; Timing Calibration Values - These are non critical in that they don't have 
; to be absolutely correct, but it's nicer to be almost right if you can....

; 100us delay loop is 8 + (n * 7) cycles.

;; Only SPEED_20MHZ should be available for the stability 
;; Baud rate should also be set higher rate, as possible. (T)

	IFDEF	SPEED_20MHZ
#define		delay100us	70
#define		baud_val	10	; 113363 baud(115K) ;; Dec.21 2003 (T)
	ENDIF

;******************************************************************************
;                               Setup Register Locations

DataVal		set		0x20
Count		set		0x21
Count2		set		0x22
Checksum	set		0x23
Rad		set		0x24
Tad		set		0x25
Cmd1		set		0x26
Cmd2		set		0x27
Parity1		set		0x28
Data11		set		0x29
Data12		set		0x2A
Data13		set		0x2B
Data14		set		0x2C
Data21		set		0x2D
Data22		set		0x2E
Data23		set		0x2F
Data24		set		0x30
Data25		set		0x31
Parity2		set		0x32
EndByte		set		0x33
MyId		set		0x34
Display		set		0x35
MyBit		set		0x36
MyGroup		set		0x37
command_offset	set		0x38	; used to hold the current output text
status_store	set		0x39	; stores STATUS reg during interrupt
w_store		set		0x3A	; stores w reg during interrupt
w_store		set		0x3B	; stores w reg during interrupt
SerialReplace	set		0x3C	; temp storage for replacement character
Time1		set		0x3d
Time0		set		0x3e
DiskNum		set		0x3f
TrackNum	set		0x40
DispCtrl	set		0x41

;;--------------Following Registers are added by Turboh ----------------

Timep		set		0x42
ResPeriod	set		0x43
SubWork		set		0x44
Time0i		set		0x45
Time1i		set		0x46
Res_AppEnd_flag	set		0x49
CountupNwork	set		0x4a
CountupN	set		0x4b
TrackNum_Tmp	set		0x4c
Int1sec_Count	set		0x4d
Int1secON	set		0x4e
PowDown		set		0x4f
Count3		set		0x50
Sleeping	set		0x51
DropCheckCount	set		0x52
MyIdCont_Flag	set		0x53
GetMyG_Count	set		0x55
TrackNum_Dsp	set		0x56
Time1iT		set		0x57
BUSMUX_exist	set		0x58
DiscNam_DSPL	set		0x59
Display_Route	set		0x5a
DSPL_ToggleC	set		0x5b
Disk0		set		0x5c
Disk1		set		0x5d
Disk2		set		0x5e
Disk3		set		0x5f
Disk4		set		0x60
Disk5		set		0x61
Disk6		set		0x62
Disk7		set		0x63
Disk8		set		0x64
Disk9		set		0x65
Appoint_Now	set		0x66
NeedToTalk	set		0x67
TMR1H_SetData	set		0x68
TMR1L_SetData	set		0x69
EE_Data		set		0x6a
CurDiscNum	set		0x6b
NewDiscNumP	set		0x6c
NewDiscNumR	set		0x6d
SlotOfMag	set		0x6e
SlotOfMg_Cd	set		0x6f
SlotOfMg_Md	set		0x70
SlotOfMagP	set		0x71
CurSource	set		0x72
ee_data		set		0x73
PCNT		set		0x74
PCNT2		set		0x75
PCNT3		set		0x76
DDir_Flag	set		0x77
DDir_Num	set		0x78

;;---DEBUG
;;Test_Data	set		0x79		;; for DEBUG ;;
;;---

;;--------------Following Values are added by Turboh ----------------
;; -- Please adjust for Your Hardware.
;; for TMR1 interrupt			;; May 22 2004 (T)
;;    Hardware Timer = 62610,  Software Timer = 10
;;	65536-62610=2926 = 0xb6e 	;; Adjusted May 29 2004 (T)
TMR1H_SetData	set		0x0b ;; TMR1H initial (=11)
TMR1L_SetData	set		0x6e ;; TMR1L initial (=110)
Int1sec_Data	set		0x0a ;; Software counter initial (=10)

;******************************************************************************
; Port definitions, which signal is where on the OUT_PORT

#define		DataBit		0
#define 	ClockBit	1
#define		BusOnBit	2
#define 	CdNotMdBit	3
#define		LEDBit		3	;; Port_B    Feb.14 2004 (T)
#define		BusOnOut	2	;; Port_B    Apr.04 2004 (T)
#define		Rel_Set		5	;; Port_B    Apr.04 2004 (T)

;******************************************************************************
;;--- Device ID
; Default definitions for responses, these may need to be changed for
; your HEADUNIT.

#define		MDX_61			;;MDX-61(MDX-5G01)
;#define		CDC1
;#define		MDC2

;;;;-----------------------------------------------
	IFDEF	MDX_61
Anyone_0	set		0x8c ;; MDX-61(MDX-5G01) (T)
Anyone_1	set		0x60
Anyone_2	set		0x06
Anyone_3	set		0x68
Anyone_4	set		0x02
Anyone_5	set		0x00

Appoint_0	set		0x8c ;; MDX-61(MDX-5G01) (T)
Appoint_1	set		0x60
Appoint_2	set		0x06
Appoint_3	set		0x68
Appoint_4	set		0x02
Appoint_5	set		0x00
	ENDIF
;;;;-----------------------------------------------
	IFDEF	CDC1
Anyone_0	set		0x8c ;; CDX-605, CDX-91 (by Mic)
Anyone_1	set		0xa0
Anyone_2	set		0x06
Anyone_3	set		0xab
Anyone_4	set		0x25
Anyone_5	set		0xa0

Appoint_0	set		0x8c
Appoint_1	set		0xa0
Appoint_2	set		0x06
Appoint_3	set		0xab
Appoint_4	set		0x25
Appoint_5	set		0xa0
	ENDIF
;;;;-----------------------------------------------
	IFDEF	MDC2
Anyone_0	set		0x8c ;; No name (by Mic)
Anyone_1	set		0x00
Anyone_2	set		0x24
Anyone_3	set		0x2c
Anyone_4	set		0x22
Anyone_5	set		0xa0

Appoint_0	set		0x8c
Appoint_1	set		0x00
Appoint_2	set		0x24
Appoint_3	set		0x2c
Appoint_4	set		0x22
Appoint_5	set		0xa0
	ENDIF

;******************************************************************************
; Value of Display_Route

GoThreeLoop	set		0x33		;; 3 -> 3 -> 3..
GoThreeOnce	set		0x30		;; 3 -> stop
GoDiscName	set		0x67		;; 6 -> 7 -> stop
GoDNandThL	set		0x63		;; 6 -> 7 -> 3 -> 3...

;******************************************************************************

Disk00_def	set		'<'		; Disk Name1
Disk01_def	set		'A'
Disk02_def	set		'U'
Disk03_def	set		'X'
Disk04_def	set		'-'
Disk05_def	set		'I'
Disk06_def	set		'N'
Disk07_def	set		'>'
Disk08_def	set		' '
Disk09_def	set		' '

Disk10_def	set		'V'		; Disk Name2
Disk11_def	set		'W'
Disk12_def	set		'-'
Disk13_def	set		'M'
Disk14_def	set		'a'
Disk15_def	set		'n'
Disk16_def	set		'i'
Disk17_def	set		'a'
Disk18_def	set		'c'
Disk19_def	set		's'

;******************************************************************************
; Start of code space

	ORG     _ResetVector
	goto	SystemSetup

;******************************************************************************
	include "interrupt.asm"
	include "functions.asm"
	include "setup.asm"
	include "receive.asm"
	include "parse.asm"
	include	"respond.asm"
	include "display.asm"

;******************************************************************************
;; Binary Version Info.
; EEPROM data
	ORG     0x2100
	DE	"040626sim20"
;******************************************************************************

	END
