;;*****************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_01
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; Sequenced responses to the Slave Poll, called so that the screen is updated.
;;--- NOTE				;; Feb. 11 2004  (T)
;; Meaning of Displays are little changed to meet "State-transition-model".
;; Since the "Display" is incremented in the next transition process
;; in the original code, I modified to set it in the end of every transition
;;      "Present_State_Num" + "Event" ==>[proc]==> "Next_State_Num"
;;    It's easy to read...

Respond_SlavePoll:			;; [permission to talk]
	movf	MyId, 0			; Check it's the right ID
	xorwf	Rad, 0			;;      Apr. 24 2004 (T)
	btfss	STATUS, Z
	goto	ReceiveBreak		; Done, wait for next command

	clrf	Checksum 		; Clear checksum

	movf	Display, 0
	xorlw	0x01			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_1

	movf	Display, 0
	xorlw	0x02			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_2

	movf	Display, 0
	xorlw	0x03			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_3

	movf	Display, 0
	xorlw	0x06			;; 3/4 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_6

	movf	Display, 0
	xorlw	0x07			; Check if 7th response
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_7


	IFDEF	NextNext
;;--- NEXT NEXT	------------------	;; Apr. 18 2004 (T)
	movf	Display, 0
	xorlw	0x10			;; =16
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_16
;;--------------------------------
	ENDIF

	goto	ReceiveBreak		; should NEVER get here!!


Respond_SlavePoll_1:
	movlw	0x77			; 'Seeking CD'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x40
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte
	
	movlw	0x00
	call	SendByte
	
	movf	TrackNum_Dsp, 0		;; Track Number  Feb. 21 2004 (T)
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + disp code
	iorlw	0x01
	call	SendByte

	movlw	0x01			;; (set ResPeriod = 1)
	movwf	ResPeriod		;; W -> ResPeriod  ;; add by turboh
					;; moved to here. Jan. 01 2004.

;;--- Added in Jan. 16 2004 (T)
	movlw	0x02			;; Next State Number=2
	movwf	Display

	goto	Respond_End		;; (T)

Respond_SlavePoll_2:			
	clrf	Timep			;; Time Counter reset (T)
	clrf	Time0			;; 
	clrf	Time1			;; 
	clrf	Time0i			;; 
	clrf	Time1i			;; 

	movlw	0x70			; 'Seeking to Track'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x00
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte
	
	movlw	0x40			;; Display availability? (T)
	call	SendByte
	
	movf	TrackNum_Dsp, 0		;; Track Number Feb. 21 2004 (T)
	call	SendByte

	movlw	0x00			;; minutes
	call	SendByte

	movlw	0x00			;; seconds
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + disp code
	iorlw	0x0d
	call	SendByte

	movf	Checksum, 0		; Send Checksum
	call	SendByte
	movlw	0x00
	call	SendByte

;;-- Relay Set			
	call	RelSet_ON		;; Apr. 07 2004 (T)


But_DSPL_Ent:
	IFDEF	IS_BUS_MUX
;;---------------------------------
	bsf	BUSMUX_exist, 0		;; set BUSMUX_exist ON
;;---------------------------------
	ENDIF

	btfss	BUSMUX_exist,0		;; check BUSMUX_exist 
	goto	DispRt_B		;; 0

DispRt_A:				;; case BUSMUX exist
	movf	MyGroup, 0		
	xorlw	0x30
	btfsc	STATUS, Z
	goto	DispRt_C		;; case BUSMUX & CD
	goto	DispRt_D		;; case BUSMUX & MD

DispRt_B:				;; case BUSMUX Not exist
	movf	MyGroup, 0		
	xorlw	0x30
	btfsc	STATUS, Z
	goto	DispRt_E		;; case Direct & CD
	goto	DispRt_F		;; case Direct & MD

DispRt_C:			;; case BUSMUX & CD & (DSPL_ON | DSPL_OFF)
	movlw	GoThreeLoop
	movwf	Display_Route		;; decided!!
	goto	Start_Route

DispRt_D:			;; case BUSMUX & MD
	movlw	GoDiscName		;; case BUSMUX & MD & DSPL_ON
	btfss	DiscNam_DSPL, 0 
	movlw	GoDNandThL		;; case BUSMUX & MD & DSPL_OFF	
	movwf	Display_Route		;; decided!!
	goto	Start_Route

DispRt_E:			;; case Direct & CD & (DSPL_ON | DSPL_OFF)
	movlw	GoThreeOnce
	movwf	Display_Route		;; decided!!
	goto	Start_Route

DispRt_F:			;; case Direct & MD
	movlw	GoDiscName		;; case Direct & MD & DSPL_ON
	btfss	DiscNam_DSPL, 0 
	movlw	GoThreeOnce		;; case Direct & MD & DSPL_OFF	
	movwf	Display_Route		;; decided!!
	goto	Start_Route

Start_Route:
	movf	Display_Route, 0
	xorlw	GoThreeLoop
	btfsc	STATUS, Z
	goto	Two_Three

	movf	Display_Route, 0
	xorlw	GoThreeOnce
	btfsc	STATUS, Z
	goto	Two_Three

	movf	Display_Route, 0
	xorlw	GoDiscName
	btfsc	STATUS, Z
	goto	Two_Six

	movf	Display_Route, 0
	xorlw	GoDNandThL
	btfsc	STATUS, Z
	goto	Two_Six

Two_Three:
	movlw	0x03			;; Next State Number=3
	movwf	Display

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)
	bsf	ResPeriod, 0 		;; (set ResPeriod = 1)

	btfsc	PowDown, 0		;; check PowerDown bit

	clrf	Display			;; if PowerDown, set Display=0
	bsf	INTCON, GIE		;; Enable interrupt

;;--- Configure TMR1 interrupt.
Config_TMR1:
	movlw	Int1sec_Data	  	;; Int1sec_Data -> Int1sec_Count
	movwf	Int1sec_Count	  	;; (software counter)

	movlw	TMR1H_SetData		;; set TMR1H initial
	movwf	TMR1H

	movlw	TMR1L_SetData		;; set TMR1H initial
	movwf	TMR1L

	bcf	PIR1, TMR1IF		;; clear overflow flag

	bsf	STATUS, RP0		;; go to Bank1
	bsf	PIE1, TMR1IE		;; Enable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bsf	INTCON, PEIE		;; Enable PEIE Interrupt
	nop
	bsf	INTCON, GIE		;; Enable GEIE Interrupt

	bsf	T1CON, TMR1ON		;; set TMR1ON = Start

;;--					;; Jun. 20 2004 (T)
	call	IssueSlaveBreak		;; call ISB
;;--

	goto	ReceiveBreak		; Done, wait for next command

Two_Six:
	movlw	0x06			;; Next State Number=6
	movwf	Display

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)
	bsf	ResPeriod, 0		;; (set ResPeriod = 1)

Config_TMR1_2:				;; setup TMR0
	movlw	Int1sec_Data	  	;; Int1sec_Data -> Int1sec_Count
	movwf	Int1sec_Count	  	;; (software counter)

	movlw	TMR1H_SetData		;; set TMR1H initial
	movwf	TMR1H

	movlw	TMR1L_SetData		;; set TMR1H initial
	movwf	TMR1L

	bcf	PIR1, TMR1IF		;; clear overflow flag

;;--- Disable Interrpt until DiscName Displaying has been completed  (T)
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	nop
	bcf	INTCON, PEIE		;; Disable PEIE Interrupt

	bsf	STATUS, RP0		;; go to Bank1
	bcf	PIE1, TMR1IE		;; Disable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bcf	T1CON, TMR1ON		;; set TMR1ON = Stop

;;--					;; Jun. 20 2004 (T)
	call	IssueSlaveBreak		;; call ISB
;;--

	goto	ReceiveBreak		; Done, wait for next command

	
Respond_SlavePoll_3:
	clrf	Int1secON		;; June 05 2004 (T)

	movlw	0x70			; "CD d, Track t, mm:ss"
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0x90
	call	SendByte

	movlw	0x40			;; DiskName Only (T)
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum

	movf	TrackNum_Dsp, 0		;; Track Number   Feb. 21 2004 (T)
	call	SendByte

	movf	Display_Route, 0	;; May 20 2004 (T)
	xorlw	GoThreeOnce		;;
	btfss	STATUS, Z		;;
	goto	SkipTo_TT1		;; Not GoThreeOnce

	movf    MyGroup, 0		;; case GoThreeOnce
	xorlw   0x30
	movlw   0x00            	;; for MD
	btfsc   STATUS, Z
	movlw   0xf0            	;; for CD
	movwf   Time1

SkipTo_TT1:
	movf	Time1, 0		; Track Timer  (minutes)
	call	SendByte

	movf	Display_Route, 0	;; May 20 2004 (T)
	xorlw	GoThreeOnce		;;
	btfss	STATUS, Z		;;
	goto	SkipTo_TT0		;; Not GoThreeOnce
	clrf	Time0           	;; case GoThreeOnce, for MD/CD

SkipTo_TT0:
	movf	Time0, 0		; Track Timer  (seconds)
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + Disp code
	iorwf	DispCtrl, 0
	call	SendByte

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)

	movlw	0x03			;; Next State Number=3
	movwf	Display

;;-- 					;; Added in Mar. 07 2004 (T)
	movf	Display_Route, 0
	xorlw	GoThreeOnce
	btfss	STATUS, Z
	goto	SLP3_A
	clrf	ResPeriod		;; (case GoThreeOnce), ResPeriod=0

	bcf	INTCON, PEIE			;; Disable PEIE Interrupt

	bsf	STATUS, RP0			;; go to Bank1
	bcf	PIE1, TMR1IE			;; Disable TMR1 Inerrupt
	bcf	STATUS, RP0			;; back to Bank0

	bcf	T1CON, TMR1ON			;; set TMR1ON = Stop

	goto	SLP3_B

SLP3_A:
	bsf	ResPeriod, 0		;; set ResPeriod = 1

SLP3_B:
	btfsc	PowDown, 0		;; 

	goto	Play_Stop_RE		;; case Power Down 

					;; else, Continue
	bsf	STATUS, RP0		;; go to Bank1
	bsf	PIE1, TMR1IE		;; Enable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bsf	INTCON, PEIE		;; Enable PEIE Interrupt
	nop
	bsf	INTCON, GIE		;; Enable GEIE Interrupt

	bsf	T1CON, TMR1ON		;; set TMR1ON = Start

	goto	Respond_End		;; (T)

Play_Stop_RE:
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	call	Play_Stop		;; case PowerDown, Stop Playing
	goto	Respond_End		;; (T)


Respond_SlavePoll_6:
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	movf	Disk0, 0
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movf	Disk1, 0
	call	SendByte

	movf	Disk2, 0
	call	SendByte

	movf	Disk3, 0
	call	SendByte

	movf	Disk4, 0
	call	SendByte
	
	movf	Disk5, 0
	call	SendByte

	movf	Disk6, 0
	call	SendByte

	movf	Disk7, 0
	call	SendByte

	movlw	0x0f
	call	SendByte

;;--------- for MDX-5V101R, for MDX-61    Mar. 06 2004 (T)
	movlw	0x0d			;; 1st time.
	call	SendByte

	movf	Checksum, 0		; Send Checksum
	call	SendByte
	movlw	0x00
	call	SendByte		;; 

	movlw	0x07			;; Next State Number=7
	movwf	Display

	bsf	ResPeriod, 0		;; set ResPeriod = 1

;;--					;; Jun. 20 2004 (T)
	call	IssueSlaveBreak		;; call ISB
;;--
	goto	ReceiveBreak		; Done, wait for next command


Respond_SlavePoll_7:
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	movf	Disk8, 0
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movf	Disk9, 0
	call	SendByte

;;	movf	Disk10, 0
	movlw	' '			;; (D2) DiscName3
	call	SendByte

;;	movf	Disk11, 0
	movlw	' '			;; (D3) DiscName4
	call	SendByte

;;	movf	Disk12, 0
	movlw	' '			;; (D4) DiscName5
	call	SendByte
	
;;	movf	Disk13, 0
	movlw	' '			;; (D2_1) DiscName6
	call	SendByte

;;	movf	Disk14, 0
	movlw	' '			;; (D2_2) DiscName7
	call	SendByte

;;	movf	Disk15, 0
	movlw	' '			;; (D2_3) DiscName8
	call	SendByte

	movlw	0x0f			;; 
	call	SendByte

;;------- for MDX-5V101R, and for MDX-61    Mar. 06 2004 (T)

	movlw	0x1d			;; 2nd time.
	call	SendByte

	movf	Checksum, 0		; Send Checksum
	call	SendByte
	movlw	0x00
	call	SendByte		;;

	movf	Display_Route, 0
	xorlw	GoDNandThL
	btfsc	STATUS, Z
	goto	Seven_Three		;; 

	movf	Display_Route, 0
	xorlw	GoDiscName
	btfsc	STATUS, Z
	goto	Seven_Terminate		;; 

Seven_Terminate:
	movlw	0x07
	movwf	Display
	clrf	ResPeriod		;; ResPeriod = 0
	goto	ReceiveBreak		; Done, wait for next command

Seven_Three:
	movlw	0x03			;; Next State Number=3
	movwf	Display
	movlw	0x01			;; (set ResPeriod = 1)
	movwf	ResPeriod		;; W -> ResPeriod

					;; Enable Interrpt (T)
	bsf	STATUS, RP0		;; go to Bank1
	bsf	PIE1, TMR1IE		;; Enable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bsf	INTCON, PEIE		;; Enable PEIE Interrupt
	nop
	bsf	INTCON, GIE		;; Enable GEIE Interrupt

	bsf	T1CON, TMR1ON		;; set TMR1ON = Start

	goto	ReceiveBreak		; Done, wait for next command


	IFDEF	NextNext

;;--- NEXT NEXT----------------		;; Apr. 18 2004  (T)
;;--  Changed to send [Tad,11,b0,Num,ff,00,00,00]
Respond_SlavePoll_16:			;; label changed Apr. 18 2004 (T)
	movf	CurSource, 0
	call	SendByte

	movlw	0x11		;; 
	call	SendByte

	movlw	0xb0			;; Direct Num
	call	SendByte

	movf	CurDiscNum, 0		;; CurDiscNum (= new DiscNum)
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum

	movlw	0xff
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00			;; 10 disc CDC
	call	SendByte

	movf	Checksum, 0		; Send Checksum
	call	SendByte

	movlw	0x00
	call	SendByte		;; 

	clrf	Display			;; set Next State Number=0

	clrf	ResPeriod		;; set ResPeriod=0

	bsf	PowDown, 0		;; PowerDown!!

	goto	ReceiveBreak		; Done, wait for next command

;;-------------------------------
	ENDIF	;;<NextNext>

;;*****************************************************************************

;;----- End of display.asm
