;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_01
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************

; Work out which 'command' we have received and issue the appropriate response

Interpret:
	movf	Cmd1, 0		;; [108100c0] BUS_MUX Ejecting Check	
	xorlw	0x00			;; for XA-C30  Feb. 21 2004 (T) 
	btfsc	STATUS, Z
	goto	MUX_PongEject

	movf	Cmd1, 0
	xorlw	0x01
	btfsc	STATUS, Z
	goto	Cmd1_was_01

	movf	Cmd1, 0
	xorlw	0x02
	btfsc	STATUS, Z
	goto	Respond_Appoint

	movf	Cmd1, 0
	xorlw	0x20
	btfsc	STATUS, Z
	goto	Cmd_Selected

;;----Button Released-------
	movf	Cmd1, 0
	xorlw	0x38			;; for MDX-5V101R (REPEAT:4a)->DSPL_BP
	btfsc	STATUS, Z
	goto	But_DSPL

	IFDEF	DEBUG
;;---------------------------
	movf	Cmd1, 0
	xorlw	0x58			;; for MDX-61 (REPEAT:4a)->DSPL_BP
	btfsc	STATUS, Z
	goto	But_DSPL
;;---------------------------
	ENDIF

	movf	Cmd1, 0
	xorlw	0x25		;; for MDX-5V101R (SHUFFLE:0a)->Toggle_DSPL
	btfsc	STATUS, Z
	goto	But_DSPL2

	IFDEF	DEBUG
;;----------------------------
	movf	Cmd1, 0
	xorlw	0x45			;; for MDX-61 (SHUFFLE:0a)->Toggle_DSPL
	btfsc	STATUS, Z
	goto	But_DSPL2
;;----------------------------
	ENDIF

;;----Power ON/OFF--------------------
	movf	Cmd1, 0
	xorlw	0x87
	btfsc	STATUS, Z
	goto	Cmd_PowerOff		;;[sys down[878a,876b,8792]]

	movf	Cmd1, 0
	xorlw	0xF0
	btfsc	STATUS, Z
	goto	Cmd_Deselected


;;---NEXT NEXT- AS button remap to Next Disk 	Apr. 18 2004 (T)
	IFDEF	NextNext
;;--------------------------
	movf	Cmd1, 0
	xorlw	0x29			;;for MDX-5V101R [0x296a] AS pressed
	btfsc	STATUS, Z
	goto	But_Next

	IFDEF	DEBUG
;;--------------------------
	movf	Cmd1, 0
	xorlw	0x50			;;for MDX-61 [0x500a] Enter pressed
	btfsc	STATUS, Z
	goto	But_Next_Test
;;--------------------------
	ENDIF	;; <DEBUG>
;;--------------------------
	ENDIF	;; <NextNext>

	movf	Cmd1, 0			;;Current disk number monitoring
					;;[0x70,id,90,xx,xx,xx,xx,Nx]
	xorlw	0x90			;;  Apr. 24 2004 (T)
	btfsc	STATUS, Z
	goto	Current_DiscP		;; May 22 2004 (T)

	movf	Cmd1, 0			;;Current disk number monitoring
					;;[0x70,id,c0,xx,xx,xx,xx,xx,
					;;	xx,xx,xx,xx,Nx]
	xorlw	0xc0			;;  Apr. 24 2004 (T)
	btfsc	STATUS, Z
	goto	Current_Disc3

	movf	Cmd1, 0			;;Magazine Info.
					;;[0x70,id,95,xx,xx,xx,xx,xN]
	xorlw	0x95			;;  Apr. 24 2004 (T)
	btfsc	STATUS, Z
	goto	Magazine_Info

	movf	Cmd1, 0			;; Direct Disc Button monitor
	xorlw	0x3c			;; [0x10,21,3c,Na] 
	btfsc	STATUS, Z		;; 
	goto	DDirNum_Store

	goto	Cmd_Unkown

Cmd1_was_01:
	movf	Cmd2, 0
	btfsc	STATUS, Z			; Check for 'Init'
	goto	WarmBoot

	movf	Cmd2, 0
	xorlw	0x02				; Check for 'Anyone'
	btfsc	STATUS, Z
	goto	Respond_Anyone

	movf	Cmd2, 0
	xorlw	0x11				; Check for 'Alive'
	btfsc	STATUS, Z
	goto	Respond_Hello

	movf	Cmd2, 0
	xorlw	0x12				; Check for 'Ping'
	btfsc	STATUS, Z
	goto	Respond_Ping

	movf	Cmd2, 0
	xorlw	0x13				; Check for 'Slave Poll'
	btfsc	STATUS, Z
	goto	Respond_SlavePoll

	movf	Cmd2, 0
	xorlw	0x15				; Check for 'Master Poll'
	btfsc	STATUS, Z
	goto	Respond_MasterPoll


	IFDEF	CdMd_SW
;;-------------------------------------	;; no statement
	ELSE	;; <IFNDEF  CdMd_SW>
;;---------------------------------- 	;;in CD/MD Auto select mode
	movf	Cmd2, 0			;;[xx,10.01,0f] "NO ID resource "
	xorlw	0x0f			;; Check for "NO Resource"
	btfsc	STATUS, Z
	goto	Respond_ReconfReq	
;;---------------------------------------------
	ENDIF	;; <CdMd_SW>

	goto	Cmd_Unkown			; Unknown command

Cmd_Unkown:
	goto	ReceiveBreak


Cmd_Selected:
;;--- Added checking if Tad is Master. (T)
	movf	Tad, 0			;; 
	xorlw	0x10			;; Is Tad Master?
	btfss	STATUS, Z	
	goto	ReceiveBreak		;; If not, ignore

	movf	Rad, 0			;; 
	subwf	MyId, 0			;; Is Rad MyID?
	btfsc	STATUS, Z
	goto	Cmd_Selected2		;; (MyID)

	call	Play_Stop		;; Stop playing if Rad is not MyID.
	goto	ReceiveBreak		;;

Cmd_Selected2:
	clrf	PowDown			;; set PowerON. (T)
	movlw	0x01			; Restart the display sequence
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)

	clrf	DropCheckCount		;; clear DropCheckCount

					;; Case CD, add 0xf0 with TrackNum
	movf	MyGroup, 0		;; MyGroup -> W
	xorlw	0x30
	movlw	0x00			;; 0x00 -> W  (offset, case MD)
	btfsc	STATUS, Z		;;
	movlw	0xf0			;; 0xf0 -> W  (offset, case CD)

	addwf	TrackNum, 0		;; TrackNum + offset -> W
	movwf	TrackNum_Dsp		;; TrackNumber for Display

	goto	ReceiveBreak

Cmd_PowerOff:				;;[0x87**]
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	nop
	bcf	INTCON, PEIE		;; Disable PEIE Interrupt
	nop				;;
	bcf	INTCON, INTE		;; Disable RB0/INT Interrupt
	bcf	T1CON, TMR1ON		;; set TMR1ON = Stop

	bsf	STATUS, RP0		;; go to Bank1
	bcf	PIE1, TMR1IE		;; Disable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	call	Play_Stop		;; Stop Playing.
	call	Waitfor15
	call	Play_Stop		;; retry
	bsf	PowDown, 0		;; (set =1) PowerDown!!

;; --- 0x8792 : stop -> sleep		;; Jan. 30 2004  (T)
	movf	Cmd2, 0
	xorlw	0x92
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

;; --- 0x8713 : stop -> sleep		;; Jan. 30 2004  (T)
	movf	Cmd2, 0
	xorlw	0x13
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

;; --- 0x8793 : play -> sleep		;; Jan. 30 2004  (T)
	movf	Cmd2, 0
	xorlw	0x93
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

;; --- 0x8722 : BusConfig -> sleep	;; Jan. 31 2004  (T)
	movf	Cmd2, 0
	xorlw	0x22
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

;; --- 0x8712 : play -> sleep		;; Jan. 31 2004  (T)
	movf	Cmd2, 0
	xorlw	0x12
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

;; --- 0x8732 : -- -> sleep		;; Jan. 31 2004  (T)
	movf	Cmd2, 0
	xorlw	0x32
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

	goto	ReceiveBreak2		;; (stopper)

Cmd_PowerOff2:				;;[0x87*2,3] (sys down)  (T)
;; --- Wait for 0.1sec,  and watch the BusOn line goes Low.
	call	Waitfor100ms		;; wait for 0.1s
	btfsc	OUT_PORT, BusOnBit	; Test for BusOn being low
	goto	Cmd_PowerOff2		;; (High) retry.
	
;; --- Configure RB0/INT setting
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	nop
	bcf	INTCON, PEIE		;; Disable PEIE Interrupt
	nop				;;
	bcf	INTCON, INTE		;; Disable RB0/INT Interrupt
	bcf	T1CON, TMR1ON		;; set TMR1ON = Stop

	bsf	STATUS, RP0		;; go to Bank1
	bcf	PIE1, TMR1IE		;; Disable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bsf	STATUS, RP0		;; go Bank1
	nop
	bsf	OPTION_REG, INTEDG	;; INTEDG=1

	bsf	TRISB, 0		;; set RB0/INT=1 (bit0) as input
					;;    Modified  Feb. 14 2004 (T)
	bcf	STATUS, RP0		;; go Bank0
	movlw	0x07
	movwf	CMCON			;; disable Comparator

	bcf	PORTB, 0		;;-- Modified  Feb. 14 2004 (T)> --
	bcf	INTCON, INTF		;; clear RB0/INT flag
	nop
	bsf	INTCON, INTE		;; enable RB0/INT
	nop
	bsf	INTCON, GIE		;; enable GIE

;;--- Go Sleep
;;RB0/INT interrupt will cause some instructions after wakeup.  (T)
;;    (while the 2nd or 3rd NOP is running. may be.)

	bsf	MyIdCont_Flag, 0	;; set MyIdCont_Flag=1 

	call	ResetBusOnOut		;; BusOnOut OFF	   Apr. 05 2004
	call	LED_OFF			;; LED light OFF

	bsf	Sleeping, 0		;; set Sleeping=1 (sleeping)
	clrwdt				;; WDT clear
	sleep				;; go PIC-sleep
	nop				;; --- wake up ---
	nop				;; 
	nop				;; <INT activates here>
	nop				;;

;;---NOTE
;; Sleeping flag (00:running, 01:sleepig, 02:wakeup)
;; is set to "01" while going into sleep (herein this function), 
;; and is set to "02" while wakeup in RB0/INT(BusOn high is re-detected) (T)

	movf	Sleeping, 0	;; check whether I'm just in a "wakeup".
	xorlw	0x00			;; 00:running, 01:sleepig, 02:wakeup
	btfsc	STATUS, Z
	goto	SystemSetup		;; If "running", go SystemReset 
					;; (because something is wrong...)
	movf	Sleeping, 0		
	xorlw	0x01
	btfsc	STATUS, Z
	goto	Resume			;; DEBUG - under consideration....

	movf	Sleeping, 0
	xorlw	0x02
	btfsc	STATUS, Z
	goto	Resume			;; If it's just wakeup, go resume.

	goto	Cmd_PowerOff2		;;(stopper)

Cmd_Deselected:
	movf	Cmd2, 0			; ensure it's the right ID
	subwf	MyId, 0
	btfsc	STATUS, Z
	goto	Cmd_Selected2		; actually it's me selected

	call	Play_Stop		;; Stop Playing.
	call	Waitfor15
	call	Play_Stop		;; retry.
	goto	ReceiveBreak		;; 


;;--- [108100c0] Stop Playing caused by BUX_MUX Ejecting
MUX_PongEject:				;; for XA-C30  Feb. 21 2004 (T) 
	movf	Tad, 0
	xorlw	0x81			;; 81: BUS_MUX
	btfss	STATUS, Z
	goto	ReceiveBreak		;; other

	movf	Cmd2, 0			;; case Tad=81
	xorlw	0xC0			;; C0: Ejecting
	btfsc	STATUS, Z
	call	Play_Stop		;; case BUS_MUX Ejecting,
					;; Stop Playing.
	goto	ReceiveBreak		;; 

;;--- Toggle status of DSPL Button	;; Mar. 07 2004 (T)
But_DSPL:			;; [10 21 38 4a]   for MDX-5V101R(REPEAT)
				;; [10 21 58 4a]   for MDX-61(REPEAT)
	movf	Display, 0		
	xorlw	0x00			;; Playing or Not?
	btfsc	STATUS, Z
	goto	ReceiveBreak		;; case Idle, goto RB

	movf	Cmd2, 0			;; case Playing, check Cmd2
	xorlw	0x4a			;; (0x4a: REPAST Button released)
	btfsc	STATUS, Z
	goto	DSPL_BP			;;

	goto	ReceiveBreak		;; else


But_DSPL2:			;; [10 21 25 0a]   for MDX-5V101R(SHUFFLE)
				;; [10 21 45 0a]   for MDX-61(SHUFFLE)
	movf	Display, 0		
	xorlw	0x00			;; Playing or Not?
	btfsc	STATUS, Z
	goto	ReceiveBreak		;; case Idle, goto RB

	movf	Cmd2, 0			;; case Playing, check Cmd2
	xorlw	0x0a			;; (0x6a: AS Button released)
	btfsc	STATUS, Z
	goto	Toggle_DSPL		;;

	goto	ReceiveBreak		;; else


DSPL_BP:
	incf	DiscNam_DSPL, 0		;; Button released
	andlw	0x01			;; toggle DiscNam_DSPL
	movwf	DiscNam_DSPL		;; store DiscNam_DSPL
	goto	But_DSPL_Ent		;; within the "Respond_SlavePoll_2"


;;---  Switch the Disk0-Disk9 from Disk0x_def to Disk1x_def  (T)
;;      set "<AUX-IN>  "  by default.
Toggle_DSPL:
	incf	DSPL_ToggleC, 1
	btfss	DSPL_ToggleC, 0		;; check 0bit position
	goto	Toggle_DSPL0		;; case Bit=0
	goto	Toggle_DSPL1		;; case Bit=1
Toggle_DSPL0:				;; default setting
	movlw	Disk00_def
	movwf	Disk0
	movlw	Disk01_def
	movwf	Disk1
	movlw	Disk02_def
	movwf	Disk2
	movlw	Disk03_def
	movwf	Disk3
	movlw	Disk04_def
	movwf	Disk4
	movlw	Disk05_def
	movwf	Disk5
	movlw	Disk06_def
	movwf	Disk6
	movlw	Disk07_def
	movwf	Disk7
	movlw	Disk08_def
	movwf	Disk8
	movlw	Disk09_def
	movwf	Disk9
	goto	But_DSPL_Ent
Toggle_DSPL1:				;; special setting
	movlw	Disk10_def
	movwf	Disk0
	movlw	Disk11_def
	movwf	Disk1
	movlw	Disk12_def
	movwf	Disk2
	movlw	Disk13_def
	movwf	Disk3
	movlw	Disk14_def
	movwf	Disk4
	movlw	Disk15_def
	movwf	Disk5
	movlw	Disk16_def
	movwf	Disk6
	movlw	Disk17_def
	movwf	Disk7
	movlw	Disk18_def
	movwf	Disk8
	movlw	Disk19_def
	movwf	Disk9
	goto	But_DSPL_Ent


	IFDEF	NextNext
;; ---NEXT NEXT --			;; Apr.18 2004  (T)
But_Next:				;;[0x296a] AS button (pressed)
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	ReceiveBreak		;; case Playing, do Nothing

	movf	Cmd2, 0			;; case Not Playing(Display=0), 
					;; check Cmd2
	xorlw	0x60			;; ([0x2960]: AS Button pressed)
	btfss	STATUS, Z		

	goto	ReceiveBreak		;; not [0x296a], goto RB.

Next_Next:				;; case [0x296a]
	movf	CurDiscNum, 0		;; check CurDiscNum = not null.
	xorlw	0x00			;; 
	btfsc	STATUS, Z
	goto	ReceiveBreak		;; (CurDiscNum=0) Do nothing.

	movf	CurSource, 0		;; case CD_1
	xorlw	0x31
	btfsc	STATUS, Z
	call	GoNext_Cd		;; May. 4 2004 (T)

	movf	CurSource, 0		;; case MD_1
	xorlw	0xd1
	btfsc	STATUS, Z
	call	GoNext_Md		;; May. 4 2004 (T)

	movf	CurSource, 0		;; case CD_2
	xorlw	0x32
	btfsc	STATUS, Z
	call	GoNext_Cd		;; May. 4 2004 (T)

	movf	CurSource, 0		;; case MD_2
	xorlw	0xd2
	btfsc	STATUS, Z
	call	GoNext_Md		;; May. 4 2004 (T)

	goto	ReceiveBreak		;; else, do Nothing(ex 0xdb..).

GoNext_Cd:				;; May. 4 2004 (T)
	call	GetMag_Cd
	goto	Next_Next2
	
GoNext_Md:				;; May. 4 2004 (T)
	call	GetMag_Md
	goto	Next_Next2

;;--					;; Jun. 18 2004 (T)
Next_Next2:
	btfss	DDir_Flag, 0		;; DDir_Flag = 0x01 ?
	goto	Next_Next2skip		;; case Not set, skip

	movf	DDir_Num, 0		;; case flag is set,
	movwf	CurDiscNum		;; DDir_Num -> CurDiscNum
	clrf	DDir_Flag		;; clear DDir_Flag


Next_Next2skip:
	movf	CurDiscNum, 0		;; (Max DiscNum = 10 (0x0a))
	subwf	SlotOfMagP, 0		;; SlotOfMag - CurDiscNum -> W
					;;
	btfss	STATUS, C
	clrf	CurDiscNum		;; CurDiscNum=0
					;; else NOP

	incf	CurDiscNum, 1		;; CurDiscNum+1 -> CurDiscNum.
	swapf	CurDiscNum, 0		;; swapf(CurDiscNum) -> W

	movwf	NewDiscNumP		;; New Disc Number (Pressed)
	addlw	0x0a
	movwf	NewDiscNumR		;; New Disc Number (Released)

	clrf	PowDown			;; One time power up... (Display 8)

	movlw	0x10			;; set Next State Number=16
	movwf	Display

	call	IssueSlaveBreak

	goto	ReceiveBreak	;; continues to Respond_Hello <respond.asm>

	IFDEF	DEBUG
;;--------------------------
But_Next_Test:				;; for Testing (with MDX-61)
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	ReceiveBreak		;; case Playing, do Nothing

	movf	Cmd2, 0			;; case Not Playing(Display=0,16), 
					;; check Cmd2
	xorlw	0x00			;; ([0x5000]: Enter Button pressed)
	btfss	STATUS, Z		
	goto	ReceiveBreak		;; not [0x5e7a], goto RB.
					;; not [0x500a], goto RB.
	goto	Next_Next		;; case [0x5e7a]
					;; case [0x500a]
;;----------------------------
	ENDIF	;; <DEBUG>
;;--------------------------------
	ENDIF	;; <NextNext>


;;--					;; May 22 2004 (T)
Current_DiscP:
	movf	Tad, 0			;; Tad -> W
	andlw	0xf0
	xorlw	0x30
	btfsc	STATUS, Z
	goto	Current_Disc		;; case CD

	movf	Tad, 0			;; Tad -> W
	andlw	0xf0
	xorlw	0xd0
	btfsc	STATUS, Z
	goto	Current_Disc		;; case MD

;;-- DSP button checking ------
	movf	Tad, 0			;; Tad -> W
	andlw	0xf0
	xorlw	0x90
	btfsc	STATUS, Z
	goto	ReDisplay		;; case DSP
;;-----------------------------

	goto	ReceiveBreak		;; else

Current_Disc:
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16

	goto	ReceiveBreak		;; case Playing, do Nothing

					;; case Not Playing(Display=0,16), 
	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x00			;; ([0x70id9000]: Current Playin Pos)
	btfsc	STATUS, Z		
	goto	Current_Disc2

	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x40			;; ([0x70id9040]: Current Playin Pos)
	btfsc	STATUS, Z		
	goto	Current_Disc2

	goto	ReceiveBreak		;; else

Current_Disc2:
	swapf	Data14, 0		;;
	andlw	0x0f			;;
	movwf	CurDiscNum		;; store Current DiscNum -> CurDiscNum

	movf	Tad, 0			;; get Current CD/MD Source ID
	movwf	CurSource		;; store Current Source ID

	clrf	DDir_Flag		;; clear DDir_Flag

	goto	ReceiveBreak		;; goto RB.

Current_Disc3:
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	ReceiveBreak		;; case Playing, do Nothing
					;; case Not Playing(Display=0,16), 

	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x00			;; ([0x70idc000xxxxxxxxxxxxxxxxNx]
	btfsc	STATUS, Z		
	goto	Current_Disc4

	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x20			;; ([0x70idc020xxxxxxxxxxxxxxxxNx]
	btfsc	STATUS, Z		
	goto	Current_Disc4

	goto	ReceiveBreak		;; else

Current_Disc4:
	swapf	Data25, 0		;;
	andlw	0x0f			;;
	movwf	CurDiscNum		;; store Current DiscNum -> CurDiscNum

	movf	Tad, 0			;; get Current CD/MD Source ID
	movwf	CurSource		;; store Current Source ID

	clrf	DDir_Flag		;; clear DDir_Flag

	goto	ReceiveBreak		;; goto RB.


Magazine_Info:				;; [0x70,id,95,xx,xx,xx,xx,xN]
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	ReceiveBreak		;; case Playing, do Nothing
					;; case Not Playing(Display=0,16), 
	movf	Data14, 0		;; 
	andlw	0x0f			;; Number of slot in this magazine

	btfsc	STATUS, Z		;; 
	goto	ReceiveBreak		;; if Number of slot = 0, then NOP

	movwf	SlotOfMag		;; W -> SlotOfMag
	decf	SlotOfMag, 1		;; SlotOfMag - 1 -> SlotOfMag

	movf	Tad, 0
	xorlw	0x31			;; case Tad is CD(=0x31)
	btfsc	STATUS, Z
	goto	SetMag_Cd		;; store SlotOfMag to SlotOfMg_Cd

	movf	Tad, 0
	xorlw	0x32			;; case Tad is CD(=0x32)
	btfsc	STATUS, Z
	goto	SetMag_Cd		;; store SlotOfMag to SlotOfMg_Cd

	movf	Tad, 0
	xorlw	0xd1			;; case Tad is MD(=0xd1)
	btfsc	STATUS, Z
	goto	SetMag_Md		;; store SlotOfMag to SlotOfMg_Md

	movf	Tad, 0
	xorlw	0xd2			;; case Tad is MD(=0xd2)
	btfsc	STATUS, Z
	goto	SetMag_Md		;; store SlotOfMag to SlotOfMg_Md

	goto	ReceiveBreak		;; goto RB. (stopper)

SetMag_Cd:
	movf	SlotOfMag, 0		;; SlotOfMag -> W
	xorlw	0x05
	btfsc	STATUS, Z
	goto	SetMag_Cd2		;; case 5

	movf	SlotOfMag, 0		;; SlotOfMag -> W
	xorlw	0x09
	btfsc	STATUS, Z
	goto	SetMag_Cd2		;; case 9

	goto	ReceiveBreak		;; goto RB. (stopper)

SetMag_Cd2:
	call	GetMag_Cd_EPROM		;; result -> W
	xorwf	SlotOfMag, 0		;; 
	btfsc	STATUS, Z		;;
	goto	ReceiveBreak		;; goto RB.

					;; else, 
	movf	SlotOfMag, 0		;; SlotOfMag -> W
	call	StoreMag_Cd_EPROM	;; Store to EEPROM
	goto	ReceiveBreak		;; goto RB.

SetMag_Md:
	movf	SlotOfMag, 0		;; SlotOfMag -> W
	xorlw	0x05
	btfsc	STATUS, Z
	goto	SetMag_Md2		;; case 5

	movf	SlotOfMag, 0		;; SlotOfMag -> W
	xorlw	0x09
	btfsc	STATUS, Z
	goto	SetMag_Md2		;; case 9

	goto	ReceiveBreak		;; goto RB. (stopper)

SetMag_Md2:
	call	GetMag_Md_EPROM		;; result -> W
	xorwf	SlotOfMag, 0		;; 
	btfsc	STATUS, Z		;;
	goto	ReceiveBreak		;; goto RB. 
					;; else, 
	movf	SlotOfMag, 0		;; SlotOfMag -> W
	call	StoreMag_Md_EPROM	;; Store to EEPROM
	goto	ReceiveBreak		;; goto RB. 

GetMag_Cd:
	call	GetMag_Cd_EPROM		;; result -> W
	xorlw	0x09			;; check SlotOfMg_Cd = 9
	movlw	0x05			;; case Not 9, set 5
	btfsc	STATUS, Z
	movlw	0x09			;; case 9
	movwf	SlotOfMagP		;; store  W -> SlotOfMagP
	movwf	SlotOfMg_Cd
	return

GetMag_Md:
	call	GetMag_Md_EPROM		;; result -> W
	xorlw	0x09			;; check SlotOfMg_Cd = 9
	movlw	0x05			;; case Not 9, set 5
	btfsc	STATUS, Z
	movlw	0x09			;; case 9
	movwf	SlotOfMagP		;; store  W -> SlotOfMagP
	movwf	SlotOfMg_Cd
	return

GetMag_Cd_EPROM:
	movlw	0x10		;; EEPROM ADDR for Mag_CD
	call	Eeprom_Read	;; Result -> W
	return

GetMag_Md_EPROM:
	movlw	0x11		;; EEPROM ADDR for Mag_MD
	call	Eeprom_Read	;; Result -> W
	return


StoreMag_Cd_EPROM:		;;-- set value onto Work before you call this.
	movwf	ee_data		;; W -> EE_Data
	movlw	0x10		;; EEPROM ADDR for Mag_CD
	call	Eeprom_Write
	return

StoreMag_Md_EPROM:		;;-- set value onto Work before you call this.
	movwf	ee_data		;; W -> EE_Data
	movlw	0x11		;; EEPROM ADDR for Mag_MD
	call	Eeprom_Write
	return

ReDisplay:
	movf	Display, 0		;; Display -> W
	xorlw	0x03			;; case Display=3
	btfsc	STATUS, Z
	goto	ReDisplayD3

	movf	Display, 0		;; Display -> W
	xorlw	0x06			;; case Display=6
	btfsc	STATUS, Z
	goto	ReDisplayD67

	movf	Display, 0		;; Display -> W
	xorlw	0x07			;; case Display=7
	btfsc	STATUS, Z
	goto	ReDisplayD67

	goto	ReceiveBreak		;; else

ReDisplayD3:
	movf	Display_Route, 0
	xorlw	GoThreeOnce		;; case GoThreeOnce
	btfsc	STATUS, Z		;; then redisplay.
	goto	Two_Three
	goto	ReceiveBreak		;; else

ReDisplayD67:
	movf	Display_Route, 0
	xorlw	GoDiscName		;; case GoDiscName
	btfsc	STATUS, Z		;; then redisplay.
	goto	Two_Six
	goto	ReceiveBreak		;; else


DDirNum_Store:				;; [0x10,21,3c,Na] 
	movf	Rad, 0			;; Rad = 10?
	xorlw	0x10
	btfss	STATUS, Z
	goto	ReceiveBreak		;; if not, goto RB

	movf	Tad, 0			;; Tad = 21?
	xorlw	0x21
	btfss	STATUS, Z
	goto	ReceiveBreak		;; if not, goto RB

	swapf	Cmd2, 0			;; swap Cmd2
	andlw	0x0f			
	movwf	DDir_Num		;; store Cmd2 -> DDir_Num

	bsf	DDir_Flag, 0		;; set = 1

	goto	ReceiveBreak		;;
	
;; --------End of parse.asm

