;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_01
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; Various responses to the commands
; These are clocked out by the master when it is ready


;******************************************************************************
Respond_Anyone:			;;  Feb. 14 2004 (T)
	movf	MyId, 1			; Test if we've got an ID
	btfsc	STATUS, Z

	goto	Respond_Anyone_main	;; (case MyId is Null) go get.

;;-- Even if MyId exists, case MyIdCont_Flag=1, you should renew your ID.

	btfss	MyIdCont_Flag, 0	;; check MyIdCont_Flag

	goto	ReceiveBreak		;; if MyIdCont_Flag=0, then Exit.
					;; if MyIdCont_Flag=1, 

	call	ResetBusOnOut		;; set BusOnOut=OFF  Apr. 11 2004 (T)
	clrf	MyId			;; and forget MyId,
	clrf	BUSMUX_exist		;; Mar. 06 2004 (T)
	clrf	Appoint_Now		;; Not my turn. ;; Apr. 07 2004 (T)

;;--
	movlw	0x12		;; EEPROM data for GetMyGroup -> W
	call	Eeprom_Read	;; EEPROM read -> W
	xorlw	0x01		;; check value = 1 or not
	movlw	0xff		;; case NOT 0x01, set 0xff (next = MD mode)
	btfsc	STATUS, Z	;;
	movlw	0x01		;; case 0x01,  set 0x01 (next = CD mode)
	movwf	GetMyG_Count	;; set  GetMyG_Count

Respond_Anyone_main:
;;;--- Attempting is limited to 8 times   ;; May 29 2004  (T)
	movf	GetMyG_Count, 0	;; GetMyG_Count -> W     (0xff to 0x09)
	addlw	0x01		;; GetMyG_Count + 1 -> W (0x00 to 0x0a)
	sublw	0x09		;; 9 - W -> new W
	btfss	STATUS, C	;;
	goto	GoDummyMode	;; (negative) BusOnOut=ON, and abort.
				;; (positive or zero) continue
;;---
	call	ResetBusOnOut		;; set BusOnOut=OFF  Apr. 11 2004 (T)

	clrf	Checksum 		; Clear checksum
	movlw	0x10			; 'I'm a .....'
	call	SendByte

	IFDEF	CdMd_SW			;; case Fixed by Hardware switch (T)
	movf	MyGroup, 0
	call	SendByte

	ELSE				;; case Automatic mode selection (T)
	call	GetMyGroup		;; return MyGroup on W  (functions.asm)
	movwf	MyGroup			;; store W -> MyGroup
	call	SendByte
	ENDIF

Respond_Anyone2:
	movlw	Anyone_0
	call	SendByte

	movlw	Anyone_1
	call	SendByte

	movf	Checksum, 0		; Save Current Checksum
	movwf	Count2

	movf	Checksum, 0		; Send Checksum
	call	SendByte

	movf	Count2, 0		; Restore Checksum
	movwf	Checksum
	
	movlw	Anyone_2
	call	SendByte

	movlw	Anyone_3
	call	SendByte

	movlw	Anyone_4
	call	SendByte

	movlw	Anyone_5
	call	SendByte

	bsf	Appoint_Now,0		;; Set flag (It's My turn)
	

Respond_End:
	movf	Checksum, 0		; Send Checksum
	call	SendByte
	
	movlw	0x00
	call	SendByte
	
	goto	ReceiveBreak		; Done, wait for next command


GoDummyMode:				;; May 29 2004 (T)
	call	SetBusOnOut		;; set BusOnOut=ON
	goto	ReceiveBreak


Respond_Appoint:
	btfss	Appoint_Now, 0		;; My turn ?

	goto	ReceiveBreak		;; (Not My turn) goto RB.
					;; (My turn) continue.
	movf	Rad, 0			; Store allocated ID
	movwf	MyId

	movf	Cmd2, 0			; Store bit position 
	movwf	MyBit			; (for SlavePoll response)

	clrf	Res_AppEnd_flag		;;
	clrf	MyIdCont_Flag		;; Feb. 14 2004 (T)
	clrf	Appoint_Now		;; Apr. 07 2004 (T)

	call	SetBusOnOut		;; set BusOnOut=ON  Apr. 07 2004 (T)

Respond_App2:
	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'OK I'm ID=X'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movf	MyGroup, 0
	xorlw	0x30
	btfss	STATUS, Z		;; CD or MD?
	goto	Respond_App3		;; case MD

;;-- case CD
	movlw	Appoint_0		; different response
	call	SendByte

	movlw	Appoint_1
	call	SendByte

	movf	Checksum, 0		; Save Current Checksum
	movwf	Count2

	movf	Checksum, 0		; Send Checksum
	call	SendByte

	movf	Count2, 0		; Restore Checksum
	movwf	Checksum
	
	movlw	Appoint_2
	call	SendByte

	movlw	Appoint_3
	call	SendByte

	movlw	Appoint_4
	call	SendByte

	movlw	Appoint_5
	call	SendByte

	goto	Respond_End

;;--- (from Respond_App2, case MD)	;; added Apr. 11 2004 (T)
;;--- Same as original ver. of Respond_Anyone2.
Respond_App3:
	movlw	Anyone_0
	call	SendByte

	movlw	Anyone_1
	call	SendByte

	movf	Checksum, 0		; Save Current Checksum
	movwf	Count2

	movf	Checksum, 0		; Send Checksum
	call	SendByte

	movf	Count2, 0		; Restore Checksum
	movwf	Checksum
	
	movlw	Anyone_2
	call	SendByte

	movlw	Anyone_3
	call	SendByte

	movlw	Anyone_4
	call	SendByte

	movlw	Anyone_5
	call	SendByte

	goto	Respond_End

;;--- 
Respond_Hello:				;; "Ping End"
;;--- Added ISB invoking 		Jan. 14 2004 (T)
;; If Display= 1,2,3,6,7,16 then call ISB_P2.
;;   Remarks: See "ReceiveBreak" in case of Display=3.
	call	LED_ON			;;

	movf	MyId, 1			; Test for ID
	btfsc	STATUS, Z
	goto	Respond_Hello2		;; Not Me.

	movf	Display, 0
	xorlw	0x01
	btfsc	STATUS, Z		;; 
	goto	IssueSlaveBreak_P2	;; case Display=1

	movf	Display, 0
	xorlw	0x02			;;- recovery (for Display=2)
	btfsc	STATUS, Z		;; 
	goto	IssueSlaveBreak_P2	;; case Display=2

	movf	Display, 0
	xorlw	0x06
	btfsc	STATUS, Z		;; 
	goto	IssueSlaveBreak_P2	;; case Display=6

	movf	Display, 0
	xorlw	0x07			;;- recovery (for Display=7)
	btfsc	STATUS, Z		;; 
	goto	IssueSlaveBreak_P2	;; case Display=7

	IFDEF	NextNext
;;;--- NEXT NEXT ---------------	;; Apr. 18 2004 (T)
	movf	Display, 0		;;- recovery (for Display=16)
	xorlw	0x10			;; changed Apr. 18 2004 (T)
	btfsc	STATUS, Z		;; case Display=16 
	goto	IssueSlaveBreak_P3	;;
;;;------------------------------
	ENDIF


;;--- case Display=3
;; Add invoking ISB_P2 case Display=3 and Int1secON=1 .  Feb.02 2004  (T)

	movf	Display, 0
	xorlw	0x03		
	btfss	STATUS, Z		;; check if Display=3. 
	goto	ReceiveBreak		;; Abort Display is not equal to 3

	btfss	Int1secON, 0		;; Int1secON = ON(1)?

	goto	ReceiveBreak		;; Abort if Int1secON is not 1.
					;; case Display=3 & Int1secON=1
	clrf	Int1secON		;; clear the flag
	goto	IssueSlaveBreak_P2 	;; 

	goto	ReceiveBreak	

Respond_Hello2:
	movf	Res_AppEnd_flag, 0	;; Res_AppEnd_flag -> W	
	sublw	0x00			;; 0x00 - flag
	btfss	STATUS,  C
	goto	ReceiveBreak		;; (negative. endflag=ON, Abort)
					;; (positive. endflag=OFF, continue)
	clrf	Checksum 		; Clear checksum
	movlw	0x10			; 'You've missed me!!'
	call	SendByte

	movlw	0x18
	call	SendByte

	movlw	0x04
	call	SendByte

	movlw	0x00
	call	SendByte

	goto	Respond_End


Respond_Ping:
	movf	MyId, 0			; Check it's the right ID
					; MyId -> W
	xorwf	Rad, 0			;; 	Apr. 08 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_Ping2		;; Rad is Me. goto Respond_Ping2.

	movf	Rad, 0			;; Rad -> W
	xorlw	0x81			;; (0x81:BUS_MUX)
	btfss	STATUS, Z		;;
	goto	ReceiveBreak		; Done, wait for the next command

	movlw	0x01			;; case Rad is BUS_MUX.
	movwf	BUSMUX_exist		;; set BUSMUX_exist=1
	goto	ReceiveBreak		;;

Respond_Ping2:
	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'I'm playing'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0x00
	call	SendByte

;;-- Display 1,2,3,6,7 represent for "Playing"
;;-- and  0,16(=0x10) represent for  "Idle".
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z
	goto	Pong_Playing		;; (1,2,3,6,7)
Pong_Idle:
	movlw	0x80			; 'Idle'
	call	SendByte
	goto	Respond_Ping3
Pong_Playing:
	movlw	0x00			; 'Playing'
	call	SendByte
Respond_Ping3:
	movf	Checksum, 0		; Send Checksum
	call	SendByte
	
	movlw	0x00
	call	SendByte

	call	LED_OFF			;;

	goto	ReceiveBreak		; wait for next command


IssueSlaveBreak_P2:
	movf	Display, 0
	xorlw	0x00			; Test to see if we've got 
					; something to display
	btfss	STATUS, Z
	call	IssueSlaveBreak_P	
	goto	ReceiveBreak2

;;--				;; ResPeriod force set. Apr. 18 2004 (T)
IssueSlaveBreak_P3:		;; Use in case Display=16 ONLY.
				;; (Do NOT use in any other cases)
	bsf	ResPeriod, 0		;; force set

	movf	Display, 0
	xorlw	0x00			; Test to see if we've got 
					; something to display
	btfss	STATUS, Z
	call	IssueSlaveBreak_P	
	goto	ReceiveBreak2


;;--- ISB_P				;;	Feb. 05 2004 (T)
IssueSlaveBreak_P:			;; "Call-Return" type.
	btfss	PowDown, 0		;; PowerDown state checking

	goto	ISB_Start1		;; (0):case PowerUp, Continue.
	call	Play_Stop		;; (1):case PowerDown, StopPlaying.
	return				;;      and return.
ISB_Start1:
	btfss	ResPeriod, 0		;; check ResPeriod
	goto	ISBP_Exit1		;; if Not ResPeriod=1, Exit

	clrf	DropCheckCount		;; and clear DropCheckCount
	call	IssueSlaveBreak		;; and call ISB
	return				;; and return.

;; --- Salvaging Lost packets in playing mode(Display=3) (T) 
;; To avoid stopping the sequence by the packet loss,
;; IssueSlaveBreak_P without ResPeriod re-generates ResPeriod=1.
;; --NOTE
;;   This phenomena is never seen after modifying interrupt mask setting.
;;   (in "SendByte:")

ISBP_Exit1:				;; IF Display_Route is GoThreeLoop
	movf	Display_Route, 0	;; or GoDNandThL,
	xorlw	GoThreeLoop		;; then goto ISBP_Exit11
	btfsc	STATUS, Z		;;   Mar. 7 2004  (T)
	goto	ISBP_Exit11

	movf	Display_Route, 0
	xorlw	GoDNandThL
	btfsc	STATUS, Z
	goto	ISBP_Exit11

	return				;; else, NOP return

ISBP_Exit11:
	incf	DropCheckCount, 1 	;; DropChekCount+1
	movf	DropCheckCount, 0	;;
	xorlw	0x04			;; Counter limit=4   Apr. 20 2004 (T)
	btfss	STATUS, Z		;; check if DropChekCount=16
	return				;; if Not =3,  NOP return

	bsf	ResPeriod, 0		;; if 0x00, set ResPeriod=1
	clrf	DropCheckCount		;; clear DropCheckCount

	IFDEF	DEBUG
;;--DEBUG setting --------
	incf	TrackNum, 1		;; DEBUG
;;------------------------
	ENDIF

	return

;;--- Response to Master Poll Command
Respond_MasterPoll:
	btfss	NeedToTalk, 0		;;Test wheather I need to talk

	goto	ReceiveBreak		;; case "OFF", abort	

	clrf	NeedToTalk
	clrf	ResPeriod		;; May 20 2004 (T)

	movf	Display, 0
	xorlw	0x00			; Test if we're active
	btfsc	STATUS, Z
	goto	ReceiveBreak		; wait for next command

	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'Something has changed!'
	call	SendByte

	movlw	0x18			; is to a broadcast address
	call	SendByte

	movlw	0x82
	call	SendByte

	movlw	0x00			; MyBit is 0x0? or 0x1?
	call	Bit_Frig
	call	SendByte

	movf	Checksum, 0		; Save Current Checksum
	movwf	Count2

	movf	Checksum, 0		; Send Checksum
	call	SendByte

	movf	Count2, 0		; Restore Checksum
	movwf	Checksum
	
	movlw	0x20			; MyBit is 0x2? or 0x3?
	call	Bit_Frig
	call	SendByte

	movlw	0x40			; MyBit is 0x4? or 0x5?
	call	Bit_Frig
	call	SendByte

	movlw	0x60			; MyBit is 0x6? or 0x7?
	call	Bit_Frig
	call	SendByte

	movlw	0x80			; MyBit is 0x8? or 0x9?
	call	Bit_Frig
	call	SendByte
	
	goto	Respond_End		; to do checksum and error byte


;;---
Respond_ReconfReq:			;; May 29 2004 (T)
	movf	MyId, 1			; Test if we've got an ID
	btfss	STATUS, Z
					;; case I've got MyId,
	goto	Respond_ReconfReq2	;; goto Reconfigure
	goto	ReceiveBreak		;; case NULL

Respond_ReconfReq2:
	incf	GetMyG_Count, 1		;; GetMyG_Count + 1 -> GetMyG_Count

;;-- store EEPROM 
	movlw	0x12		;; EEPROM data for GetMyGroup -> W
	call	Eeprom_Read	;; EEPROM read
	xorlw	0x01		;; check value = 1 or not
	movlw	0x01		;; case NOT 0x01, then switch to 0x01
	btfsc	STATUS, Z	;;
	movlw	0x00		;; case 0x01, then switch to 0x00
	movwf	ee_data		;; W -> EE_Data
	movlw	0x12		;; EEPROM ADDR for GetMyGroup
	call	Eeprom_Write	;; EEPROM write

;;-- send packet
	clrf	Checksum 		; Clear checksum
	movlw	0x10			; 'You've missed me!!'
	call	SendByte

	movlw	0x18
	call	SendByte

	movlw	0x04
	call	SendByte

	movlw	0x00
	call	SendByte

	movf	Checksum, 0		; Send Checksum
	call	SendByte
	
	movlw	0x00
	call	SendByte	;; Then, system goes to reboot...

	clrf	MyId			;;  MyId is force released

	goto	ReceiveBreak		; Done, wait for next command
					;; (Maybe reboot)

;******************************************************************************
;; --------End of respond.asm


